Deletes an empty bucket. The request fails if there are any live or noncurrent
objects in the bucket, but the request succeeds if the bucket only contains soft-deleted objects or
incomplete uploads, such as ongoing
[XML API multipart uploads](https://docs.cloud.google.com/storage/docs/multipart-uploads.md.txt). Does not
delete [soft-deleted objects](https://docs.cloud.google.com/storage/docs/soft-delete.md.txt).


When this API is used to delete a bucket with a [soft delete policy](https://docs.cloud.google.com/storage/docs/soft-delete.md.txt), the bucket becomes soft-deleted and the `softDeleteTime` and `hardDeleteTime` properties are set on the bucket. Objects and multipart uploads that were in the bucket at the time of deletion are also retained for the specified retention duration. When a soft-deleted bucket reaches the end of its retention duration, it is permanently deleted. The `hardDeleteTime` of the bucket always equals or exceeds the expiration time of the last soft-deleted object in the bucket.

## Required permissions

The authenticated user must have the `storage.buckets.delete` IAM
permission to use this method.

## Request

### HTTP request

```
DELETE https://storage.googleapis.com/storage/v1/b/bucket
```

In addition to [standard query parameters](https://docs.cloud.google.com/storage/docs/json_api/v1/parameters.md.txt#query),
the following query parameters apply to this method.

To see an example of how to include query parameters in a request, see the
[JSON API Overview](https://docs.cloud.google.com/storage/docs/json_api.md.txt#query_parameters) page.

### Parameters

| Parameter name | Value | Description |
|---|---|---|
| **Path parameters** |||
| `bucket` | `string` | Name of a bucket. |
| **Optional query parameters** |||
| `ifMetagenerationMatch` | `long` | If set, only deletes the bucket if its metageneration matches this value. |
| `ifMetagenerationNotMatch` | `long` | If set, only deletes the bucket if its metageneration does not match this value. |

### Request body

Do not supply a request body with this method.

## Response

If successful, this method returns an empty response body.

For information about status and error codes returned by this API, see the
[reference page](https://docs.cloud.google.com/storage/docs/json_api/v1/status-codes.md.txt).

## Try it!


Use the APIs Explorer below to call this method on live data and see the response.